#!/usr/bin/perl
# Author: I.Plisco (igor@plisco.ru)
# Aim: Gets USD rate from www.rbc.ru and saves it into text files.
#
# One file contains only rate, second - rate history.
# After getting rate it can multiply it by some coefficient (for
# example, 1.02 - to add 2%).
#
# License: GPL.
# 

# Define parameters
$URL = "http://www.rbc.ru/";	# URL with rate
$keyword = "USD  ";	# stamp of start line
$fhistory = "rate_history.txt";	# file of rate history
$frate = "rate.txt";	# file of rate
#$add_percent = 2.;	# add that percents to rate before saving
$format = "%5.1f";	# format of rate to save
$regexp = "[\\d\\/,]+";	# regular expression to extract date and rate; duplicate any "\"

use LWP::Simple;

$content = get($URL);

@arr = split(/\n/, $content);

$flag = 0;
for (@arr) {
  if ($flag == 0) {
    if (/$keyword/) {$flag = 1};
  } elsif ($flag == 1) {
    />($regexp)</;
#    print "Date: $1\n";
    $date = $1;
    $flag = 2;
  } elsif ($flag == 2) {
    />($regexp)</;
#    print "Rate: $1\n";
    $rate = $1;
    $flag = 3;
  }
}

$rate =~ s/,/./;

$rate *= (1+$add_percent/100);

$rate = sprintf($format,$rate);

open (OUT, ">>$fhistory");
print OUT "$date\t$rate\n";
close OUT;

open (OUT, ">$frate");
print OUT "$rate";
close OUT;
